﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media.Imaging;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;

namespace DiagramExample
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		MyViewModel model = new MyViewModel();

		public MainWindow()
		{
			InitializeComponent();
		}

		private void Window_Loaded(object sender, RoutedEventArgs e)
		{
			BitmapImage initialImage = new BitmapImage();
			initialImage.BeginInit();
			initialImage.UriSource = new Uri("/DiagramExample;component/Koala.jpg", UriKind.RelativeOrAbsolute);
			initialImage.EndInit();

			model = new MyViewModel() { Image = initialImage };

			RadDiagramShape StateBox = new RadDiagramShape()
			{
				Width = 100,
				Height = 100,
				Geometry = ShapeFactory.GetShapeGeometry(CommonShapeType.RectangleShape),
				Content = model,
				ContentTemplate = (DataTemplate)this.FindResource("SubItemTemplate"),
			};

			//now change dynamically the picture and the text of the StateBox: 

			//ContentPresenter myContentPresenter = FindVisualChild<ContentPresenter>(StateBox, 0);
			//Image imageInTemplate = (Image)Box.ContentTemplate.FindName("PartImageName", myContentPresenter);
			//imageInTemplate.Source = new Uri(strFilePath, UriKind.Absolute);
			//TextBlock textBlockInTemplate = (TextBlock)Box.ContentTemplate.FindName("PartID", myContentPresenter);
			//textBlockInTemplate.Text = "some part id";

			stateDiagram.AddShape(StateBox);
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			BitmapImage newImage = new BitmapImage();
			newImage.BeginInit();
			newImage.UriSource = new Uri("/DiagramExample;component/Desert.jpg", UriKind.RelativeOrAbsolute);
			newImage.EndInit();

			model.Image = newImage;
		}
	}
}
